//SIG SG550 Assault Rifle (Actually a sniper rifle here)
//Absolution: Model
//Amad: Script, icon and CI images
// -----
//Thanks to Jookia for the Hitboxes script (./hitboxes.cs)
//Thanks to StratoFortress for script reference. (Headshot check via Z axis comparison, from the AWM Sniper Rifle.)

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   GunItem.uiName = "";
}
if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Weapon_SG550 - Required Add-On Weapon_Gun not found.");
   return;
}
exec("./hitboxes.cs");

new AIConnection(botConnection)
{
   name = "Bot";
};

datablock AudioProfile(SG550fireSound)
{
   fileName    = "./SG550fire.wav"; //Thanks to ClickTeam (company, not a user) for the sound.
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("SG550",'<bitmap:add-ons/Weapon_SG550/CI> %1','%2 <bitmap:add-ons/Weapon_SG550/CI> %1',2,1);
AddDamageType("SG550head",'<bitmap:add-ons/Weapon_SG550/CI_Headshot> %1','%2 <bitmap:add-ons/Weapon_SG550/CI_Headshot> %1',2,1);

datablock projectileData(SG550bullet : GunProjectile)
{
   directDamage     = 35;
   directDamageType = $DamageType::SG550;
   impactImpulse    = 40;
   verticalImpulse  = 40;
   muzzleVelocity   = 200;
   velInheritFactor = 1;
   uiName           = "SG550 Bullet";
};

datablock ItemData(SG550item : GunItem)
{
   shapeFile    = "./SIG_SG550.dts";
   doColorShift = false;
   iconName     = "./icon";
   uiName       = "SG550 S. Rifle";
   image        = SG550Image;
};

datablock ShapeBaseImageData(SG550Image : GunImage)
{
   shapeFile    = SG550item.shapeFile;
   projectile   = SG550bullet;
   doColorShift = false;
   minShotTime  = 1000; //Prevents users from rapidly re-equipping for an instant reload

   stateSound[2]        = SG550fireSound;
   stateTimeoutValue[3] = 1;
   stateEmitterTime[3]  = 0.5;
};

function SG550Image::onMount(%this, %obj, %slot)
{
   %obj.hideNode(LHand);
   %obj.hideNode(LHook);
   %obj.playThread(2,armReadyBoth);
}

function SG550Image::onUnMount(%this, %obj, %slot)
{
   if(%obj.client.LHand == 0)
   {
      %obj.unHideNode(LHand);
   }
   else
   {
      %obj.unHideNode(LHook);
   }
   Parent::onUnmount(%this, %obj, %slot);
}
function SG550bullet::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer") //If they're a player of some kind
   {
      if(%col.getClassName() $= "AIPlayer")
      {
         %oldClient = %col.client; //Just in case the bot already had a client
         %col.client = BotConnection;
         %hitBoxList = getHitbox(%obj, %col, %pos);
         %col.client = %oldClient;
      }
      else
      {
         %hitBoxList = getHitbox(%obj, %col, %pos);
      }
      if(strReplace(%hitBoxList, "headskin", "BAM") $= %hitBoxList)
      {
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
      }
      else
      {
         %obj.client.centerPrint("\c6Nice Shot!",3);
         %obj.client.play2D(rewardSound);
         %col.damage(%obj, %pos, (125 * getWord(%obj.getScale(),2)), $DamageType::SG550head);
      }
   }
   else
   {
      parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }
}